Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 2231)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 2232)
@@ -724,536 +1456,113 @@
                       ENDIF
 
-                      tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) * &
-                                            ( k1* tswst(j,i) + k2 * qswst(j,i) )
+                      tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) *             &
+                                         ( k1 * surf_def_h(l)%shf(m) +         &
+                                           k2 * surf_def_h(l)%qsws(m) )
                    ENDDO
-
-                ENDIF
+                ENDDO
+!
+!--             Treat horizontal natural surfaces
+                surf_s = surf_lsm_h%start_index(j,i)
+                surf_e = surf_lsm_h%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k = surf_lsm_h%k(m)
+
+                   IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets ) THEN
+                       k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                       k2 = 0.61_wp * pt(k,j,i)
+                   ELSE IF ( cloud_physics )  THEN
+                       IF ( ql(k,j,i) == 0.0_wp )  THEN
+                          k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                          k2 = 0.61_wp * pt(k,j,i)
+                       ELSE
+                          theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
+                          temp  = theta * t_d_pt(k)
+                          k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *                 &
+                                        ( q(k,j,i) - ql(k,j,i) ) *             &
+                               ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
+                               ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
+                               ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                          k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
+                      ENDIF
+                   ELSE IF ( cloud_droplets )  THEN
+                      k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                      k2 = 0.61_wp * pt(k,j,i)
+                   ENDIF
+
+                   tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) *                &
+                                            ( k1 * surf_lsm_h%shf(m) +         &
+                                              k2 * surf_lsm_h%qsws(m) )
+                ENDDO
+!
+!--             Treat horizontal urban surfaces
+                surf_s = surf_usm_h%start_index(j,i)
+                surf_e = surf_usm_h%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k = surf_usm_h%k(m)
+
+                   IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets ) THEN
+                       k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                       k2 = 0.61_wp * pt(k,j,i)
+                   ELSE IF ( cloud_physics )  THEN
+                       IF ( ql(k,j,i) == 0.0_wp )  THEN
+                          k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                          k2 = 0.61_wp * pt(k,j,i)
+                       ELSE
+                          theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
+                          temp  = theta * t_d_pt(k)
+                          k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *                 &
+                                        ( q(k,j,i) - ql(k,j,i) ) *             &
+                               ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
+                               ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
+                               ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                          k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
+                      ENDIF
+                   ELSE IF ( cloud_droplets )  THEN
+                      k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                      k2 = 0.61_wp * pt(k,j,i)
+                   ENDIF
+
+                   tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) *                &
+                                            ( k1 * surf_usm_h%shf(m) +         &
+                                              k2 * surf_usm_h%qsws(m) )
+                ENDDO
 
              ENDIF
 
-          ENDIF
-
-       ENDDO
-
-    END SUBROUTINE production_e
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!------------------------------------------------------------------------------!
-    SUBROUTINE production_e_ij( i, j )
-
-       USE arrays_3d,                                                          &
-           ONLY:  ddzw, dd2zu, kh, km, prho, pt, q, ql, qsws, qswst, shf,      &
-                  tend, tswst, u, v, vpt, w
-
-       USE cloud_parameters,                                                   &
-           ONLY:  l_d_cp, l_d_r, pt_d_t, t_d_pt
-
-       USE control_parameters,                                                 &
-           ONLY:  cloud_droplets, cloud_physics, constant_flux_layer, g,       &
-                  humidity, kappa, neutral, ocean, pt_reference,               &
-                  rho_reference, use_single_reference_value,                   &
-                  use_surface_fluxes, use_top_fluxes
-
-       USE grid_variables,                                                     &
-           ONLY:  ddx, dx, ddy, dy, wall_e_x, wall_e_y
-
-       USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_diff_s_inner,                   &
-                  nzb_diff_s_outer, nzb_s_inner, nzt, nzt_diff
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i           !<
-       INTEGER(iwp) ::  j           !<
-       INTEGER(iwp) ::  k           !<
-
-       REAL(wp)     ::  def         !<
-       REAL(wp)     ::  dudx        !<
-       REAL(wp)     ::  dudy        !<
-       REAL(wp)     ::  dudz        !<
-       REAL(wp)     ::  dvdx        !<
-       REAL(wp)     ::  dvdy        !<
-       REAL(wp)     ::  dvdz        !<
-       REAL(wp)     ::  dwdx        !<
-       REAL(wp)     ::  dwdy        !<
-       REAL(wp)     ::  dwdz        !<
-       REAL(wp)     ::  k1          !<
-       REAL(wp)     ::  k2          !<
-       REAL(wp)     ::  km_neutral  !<
-       REAL(wp)     ::  theta       !<
-       REAL(wp)     ::  temp        !<
-
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  usvs  !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  vsus  !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsus  !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsvs  !<
-
-!
-!--    Calculate TKE production by shear
-       DO  k = nzb_diff_s_outer(j,i), nzt
-
-          dudx  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
-          dudy  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - &
-                              u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-          dudz  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) - &
-                              u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
-
-          dvdx  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - &
-                              v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-          dvdy  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-          dvdz  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) - &
-                              v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
-
-          dwdx  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - &
-                              w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-          dwdy  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - &
-                              w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-          dwdz  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
-
-          def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 )                       &
-                + dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + dvdz**2    &
-                + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
-
-          IF ( def < 0.0_wp )  def = 0.0_wp
-
-          tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def
-
-       ENDDO
-
-       IF ( constant_flux_layer )  THEN
-
-          IF ( ( wall_e_x(j,i) /= 0.0_wp ) .OR. ( wall_e_y(j,i) /= 0.0_wp ) )  THEN
-
-!
-!--          Position beneath wall
-!--          (2) - Will allways be executed.
-!--          'bottom and wall: use u_0,v_0 and wall functions'
-             k = nzb_diff_s_inner(j,i)-1
-
-             dudx = ( u(k,j,i+1) - u(k,j,i) ) * ddx
-             dudz = 0.5_wp * ( u(k+1,j,i) + u(k+1,j,i+1) - &
-                               u_0(j,i)   - u_0(j,i+1)   ) * dd2zu(k)
-             dvdy =          ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-             dvdz = 0.5_wp * ( v(k+1,j,i) + v(k+1,j+1,i) - &
-                               v_0(j,i)   - v_0(j+1,i)   ) * dd2zu(k)
-             dwdz = ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
-
-             IF ( wall_e_y(j,i) /= 0.0_wp )  THEN
-!
-!--             Inconsistency removed: as the thermal stratification 
-!--             is not taken into account for the evaluation of the 
-!--             wall fluxes at vertical walls, the eddy viscosity km 
-!--             must not be used for the evaluation of the velocity 
-!--             gradients dudy and dwdy
-!--             Note: The validity of the new method has not yet 
-!--                   been shown, as so far no suitable data for a 
-!--                   validation has been available
-                CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp )
-                CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp )
-                km_neutral = kappa * ( usvs(k)**2 + wsvs(k)**2 )**0.25_wp * &
-                             0.5_wp * dy
-                IF ( km_neutral > 0.0_wp )  THEN
-                   dudy = - wall_e_y(j,i) * usvs(k) / km_neutral
-                   dwdy = - wall_e_y(j,i) * wsvs(k) / km_neutral
-                ELSE
-                   dudy = 0.0_wp
-                   dwdy = 0.0_wp
-                ENDIF
-             ELSE
-                dudy = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - &
-                                   u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-                dwdy = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - &
-                                   w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-             ENDIF
-
-             IF ( wall_e_x(j,i) /= 0.0_wp )  THEN
-!
-!--             Inconsistency removed: as the thermal stratification 
-!--             is not taken into account for the evaluation of the 
-!--             wall fluxes at vertical walls, the eddy viscosity km 
-!--             must not be used for the evaluation of the velocity 
-!--             gradients dvdx and dwdx
-!--             Note: The validity of the new method has not yet 
-!--                   been shown, as so far no suitable data for a 
-!--                   validation has been available
-                CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp )
-                CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp )
-                km_neutral = kappa * ( vsus(k)**2 + wsus(k)**2 )**0.25_wp * & 
-                             0.5_wp * dx
-                IF ( km_neutral > 0.0_wp )  THEN
-                   dvdx = - wall_e_x(j,i) * vsus(k) / km_neutral
-                   dwdx = - wall_e_x(j,i) * wsus(k) / km_neutral
-                ELSE
-                   dvdx = 0.0_wp
-                   dwdx = 0.0_wp
-                ENDIF
-             ELSE
-                dvdx = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - &
-                                   v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-                dwdx = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - &
-                                   w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-             ENDIF
-
-             def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 ) +           &
-                   dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + &
-                   dvdz**2 + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
-
-             IF ( def < 0.0_wp )  def = 0.0_wp
-
-             tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def
-
-!
-!--          (3) - will be executed only, if there is at least one level
-!--          between (2) and (4), i.e. the topography must have a
-!--          minimum height of 2 dz. Wall fluxes for this case have
-!--          already been calculated for (2).
-!--          'wall only: use wall functions'
-             DO  k = nzb_diff_s_inner(j,i), nzb_diff_s_outer(j,i)-2
-
-                dudx = ( u(k,j,i+1) - u(k,j,i) ) * ddx
-                dudz = 0.5_wp * ( u(k+1,j,i) + u(k+1,j,i+1) - &
-                                  u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
-                dvdy =          ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-                dvdz = 0.5_wp * ( v(k+1,j,i) + v(k+1,j+1,i) - &
-                                  v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
-                dwdz = ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
-
-                IF ( wall_e_y(j,i) /= 0.0_wp )  THEN
-!
-!--                Inconsistency removed: as the thermal stratification 
-!--                is not taken into account for the evaluation of the 
-!--                wall fluxes at vertical walls, the eddy viscosity km 
-!--                must not be used for the evaluation of the velocity 
-!--                gradients dudy and dwdy
-!--                Note: The validity of the new method has not yet 
-!--                      been shown, as so far no suitable data for a 
-!--                      validation has been available
-                   km_neutral = kappa * ( usvs(k)**2 + & 
-                                          wsvs(k)**2 )**0.25_wp * 0.5_wp * dy
-                   IF ( km_neutral > 0.0_wp )  THEN
-                      dudy = - wall_e_y(j,i) * usvs(k) / km_neutral
-                      dwdy = - wall_e_y(j,i) * wsvs(k) / km_neutral
-                   ELSE
-                      dudy = 0.0_wp
-                      dwdy = 0.0_wp
-                   ENDIF
-                ELSE
-                   dudy = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - &
-                                      u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-                   dwdy = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - &
-                                      w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-                ENDIF
-
-                IF ( wall_e_x(j,i) /= 0.0_wp )  THEN
-!
-!--                Inconsistency removed: as the thermal stratification 
-!--                is not taken into account for the evaluation of the 
-!--                wall fluxes at vertical walls, the eddy viscosity km 
-!--                must not be used for the evaluation of the velocity 
-!--                gradients dvdx and dwdx
-!--                Note: The validity of the new method has not yet 
-!--                      been shown, as so far no suitable data for a 
-!--                      validation has been available
-                   km_neutral = kappa * ( vsus(k)**2 + & 
-                                          wsus(k)**2 )**0.25_wp * 0.5_wp * dx
-                   IF ( km_neutral > 0.0_wp )  THEN
-                      dvdx = - wall_e_x(j,i) * vsus(k) / km_neutral
-                      dwdx = - wall_e_x(j,i) * wsus(k) / km_neutral
-                   ELSE
-                      dvdx = 0.0_wp
-                      dwdx = 0.0_wp
-                   ENDIF
-                ELSE
-                   dvdx = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - &
-                                      v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-                   dwdx = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - &
-                                      w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-                ENDIF
-
-                def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 ) +           &
-                      dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + &
-                      dvdz**2 + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
-
-                IF ( def < 0.0_wp )  def = 0.0_wp
-
-                tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def
-
-             ENDDO
-
-!
-!--          (4) - will allways be executed.
-!--          'special case: free atmosphere' (as for case (0))
-             k = nzb_diff_s_outer(j,i)-1
-
-             dudx  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
-             dudy  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - &
-                                 u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-             dudz  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) - &
-                                 u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
-
-             dvdx  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - &
-                                 v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-             dvdy  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-             dvdz  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) - &
-                                 v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
-
-             dwdx  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - &
-                                 w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-             dwdy  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - &
-                                 w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-             dwdz  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
-
-             def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 ) +        &
-                   dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + &
-                   dvdz**2 + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
-
-             IF ( def < 0.0_wp )  def = 0.0_wp
-
-             tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def
-
-          ELSE
-
-!
-!--          Position without adjacent wall
-!--          (1) - will allways be executed. 
-!--          'bottom only: use u_0,v_0'
-             k = nzb_diff_s_inner(j,i)-1
-
-             dudx  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
-             dudy  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - &
-                                 u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-             dudz  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) - &
-                                 u_0(j,i)   - u_0(j,i+1)   ) * dd2zu(k)
-
-             dvdx  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - &
-                                 v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-             dvdy  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-             dvdz  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) - &
-                                 v_0(j,i)   - v_0(j+1,i)   ) * dd2zu(k)
-
-             dwdx  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - &
-                                 w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-             dwdy  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - &
-                                 w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-             dwdz  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
-
-             def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 )                       &
-                   + dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + dvdz**2 &
-                   + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
-
-             IF ( def < 0.0_wp )  def = 0.0_wp
-
-             tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def
-
-          ENDIF
-
-       ELSEIF ( use_surface_fluxes )  THEN
-
-          k = nzb_diff_s_outer(j,i)-1
-
-          dudx  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
-          dudy  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - &
-                              u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-          dudz  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) - &
-                              u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
-
-          dvdx  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - &
-                              v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-          dvdy  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-          dvdz  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) - &
-                              v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
-
-          dwdx  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - &
-                              w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-          dwdy  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - &
-                              w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-          dwdz  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
-
-          def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 ) +           &
-                dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + &
-                dvdz**2 + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
-
-          IF ( def < 0.0_wp )  def = 0.0_wp
-
-          tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def
-
-       ENDIF
-
-!
-!--    If required, calculate TKE production by buoyancy
-       IF ( .NOT. neutral )  THEN
-
-          IF ( .NOT. humidity )  THEN
-
-             IF ( use_single_reference_value )  THEN
-
-                IF ( ocean )  THEN
-!
-!--                So far in the ocean no special treatment of density flux in
-!--                the bottom and top surface layer
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tend(k,j,i) = tend(k,j,i) +                   &
-                                    kh(k,j,i) * g / rho_reference * &
-                                    ( prho(k+1,j,i) - prho(k-1,j,i) ) * dd2zu(k)
-                   ENDDO
-
-                ELSE
-
-                   DO  k = nzb_diff_s_inner(j,i), nzt_diff
-                      tend(k,j,i) = tend(k,j,i) -                  &
-                                    kh(k,j,i) * g / pt_reference * &
-                                    ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
-                   ENDDO
-
-                   IF ( use_surface_fluxes )  THEN
-                      k = nzb_diff_s_inner(j,i)-1
-                      tend(k,j,i) = tend(k,j,i) + g / pt_reference * shf(j,i)
-                   ENDIF
-
-                   IF ( use_top_fluxes )  THEN
-                      k = nzt
-                      tend(k,j,i) = tend(k,j,i) + g / pt_reference * tswst(j,i)
-                   ENDIF
-
-                ENDIF
-
-             ELSE
-
-                IF ( ocean )  THEN
-!
-!--                So far in the ocean no special treatment of density flux in
-!--                the bottom and top surface layer
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tend(k,j,i) = tend(k,j,i) +                              &
-                                    kh(k,j,i) * g / prho(k,j,i) *              &
-                                    ( prho(k+1,j,i) - prho(k-1,j,i) ) * dd2zu(k)
-                   ENDDO
-
-                ELSE
-
-                   DO  k = nzb_diff_s_inner(j,i), nzt_diff
-                      tend(k,j,i) = tend(k,j,i) -               &
-                                    kh(k,j,i) * g / pt(k,j,i) * &
-                                    ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
-                   ENDDO
-
-                   IF ( use_surface_fluxes )  THEN
-                      k = nzb_diff_s_inner(j,i)-1
-                      tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * shf(j,i)
-                   ENDIF
-
-                   IF ( use_top_fluxes )  THEN
-                      k = nzt
-                      tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * tswst(j,i)
-                   ENDIF
-
-                ENDIF
-
-             ENDIF
-
-          ELSE
-
-             DO  k = nzb_diff_s_inner(j,i), nzt_diff
-
-                IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                   tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / vpt(k,j,i) *   &
-                                         ( k1 * ( pt(k+1,j,i)-pt(k-1,j,i) ) + &
-                                           k2 * ( q(k+1,j,i) - q(k-1,j,i) )   &
-                                         ) * dd2zu(k)
-                ELSE IF ( cloud_physics )  THEN
-                   IF ( ql(k,j,i) == 0.0_wp )  THEN
+             IF ( use_top_fluxes )  THEN
+                surf_s = surf_def_h(2)%start_index(j,i)
+                surf_e = surf_def_h(2)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k = surf_def_h(2)%k(m)
+
+
+
+                   IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets )  THEN
                       k1 = 1.0_wp + 0.61_wp * q(k,j,i)
                       k2 = 0.61_wp * pt(k,j,i)
-                   ELSE
-                      theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
-                      temp  = theta * t_d_pt(k)
-                      k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *                 &
-                                    ( q(k,j,i) - ql(k,j,i) ) *          &
-                           ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
-                           ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
+                   ELSE IF ( cloud_physics )  THEN
+                      IF ( ql(k,j,i) == 0.0_wp )  THEN
+                         k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                         k2 = 0.61_wp * pt(k,j,i)
+                      ELSE
+                         theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
+                         temp  = theta * t_d_pt(k)
+                         k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *                  &
+                                    ( q(k,j,i) - ql(k,j,i) ) *                 &
+                           ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /            &
+                           ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *              &
                            ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                      k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
+                         k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
+                      ENDIF
+                   ELSE IF ( cloud_droplets )  THEN
+                      k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                      k2 = 0.61_wp * pt(k,j,i)
                    ENDIF
-                   tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / vpt(k,j,i) *   &
-                                         ( k1 * ( pt(k+1,j,i)-pt(k-1,j,i) ) + &
-                                           k2 * ( q(k+1,j,i) - q(k-1,j,i) )   &
-                                         ) * dd2zu(k)
-                ELSE IF ( cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                   tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / vpt(k,j,i) *  &
-                                     ( k1 * ( pt(k+1,j,i)-pt(k-1,j,i) ) +    &
-                                       k2 * ( q(k+1,j,i) - q(k-1,j,i) ) -    &
-                                       pt(k,j,i) * ( ql(k+1,j,i) -           &
-                                                     ql(k-1,j,i) ) ) * dd2zu(k)
-                ENDIF
-             ENDDO
-
-             IF ( use_surface_fluxes )  THEN
-                k = nzb_diff_s_inner(j,i)-1
-
-                IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ELSE IF ( cloud_physics )  THEN
-                   IF ( ql(k,j,i) == 0.0_wp )  THEN
-                      k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                      k2 = 0.61_wp * pt(k,j,i)
-                   ELSE
-                      theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
-                      temp  = theta * t_d_pt(k)
-                      k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *                 &
-                                    ( q(k,j,i) - ql(k,j,i) ) *          &
-                           ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
-                           ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
-                           ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                      k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
-                   ENDIF
-                ELSE IF ( cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ENDIF
-
-                tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) * &
-                                            ( k1* shf(j,i) + k2 * qsws(j,i) )
-             ENDIF
-
-             IF ( use_top_fluxes )  THEN
-                k = nzt
-
-                IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ELSE IF ( cloud_physics )  THEN
-                   IF ( ql(k,j,i) == 0.0_wp )  THEN
-                      k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                      k2 = 0.61_wp * pt(k,j,i)
-                   ELSE
-                      theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
-                      temp  = theta * t_d_pt(k)
-                      k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *                 &
-                                    ( q(k,j,i) - ql(k,j,i) ) *          &
-                           ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
-                           ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
-                           ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                      k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
-                   ENDIF
-                ELSE IF ( cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ENDIF
-
-                tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) * &
-                                            ( k1* tswst(j,i) + k2 * qswst(j,i) )
+
+                   tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) *                &
+                               ( k1* surf_def_h(2)%shf(m) +                    &
+                                 k2 * surf_def_h(2)%qsws(m) )
+                ENDDO
+
              ENDIF
 
@@ -1273,5 +1582,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  kh, km, u, us, usws, v, vsws, zu
+           ONLY:  kh, km, u, v, zu
 
        USE control_parameters,                                                 &
@@ -1282,20 +1591,16 @@
                   nzb_v_inner
 
+       USE surface_mod,                                                        &
+           ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_usm_h 
+
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i   !<
-       INTEGER(iwp) ::  j   !<
-       INTEGER(iwp) ::  ku  !<
-       INTEGER(iwp) ::  kv  !<
+       INTEGER(iwp) ::  i   !< grid index x-direction
+       INTEGER(iwp) ::  j   !< grid index y-direction
+       INTEGER(iwp) ::  k   !< grid index z-direction
+       INTEGER(iwp) ::  l   !< running index surface type (up- or downward-facing)
+       INTEGER(iwp) ::  m   !< running index surface elements
 
        IF ( constant_flux_layer )  THEN
-
-          IF ( first_call )  THEN
-             ALLOCATE( u_0(nysg:nyng,nxlg:nxrg), v_0(nysg:nyng,nxlg:nxrg) )
-             u_0 = 0.0_wp   ! just to avoid access of uninitialized memory
-             v_0 = 0.0_wp   ! within exchange_horiz_2d
-             first_call = .FALSE.
-          ENDIF
-
 !
 !--       Calculate a virtual velocity at the surface in a way that the
